package org.apache.bcel.generic;

import org.apache.bcel.classfile.ElementValue;
import java.io.IOException;
import java.io.DataOutputStream;
import org.apache.bcel.classfile.AnnotationElementValue;

public class AnnotationElementValueGen extends ElementValueGen
{
    private final AnnotationEntryGen a;
    
    public AnnotationElementValueGen(final AnnotationElementValue value, final ConstantPoolGen cpool, final boolean copyPoolEntries) {
        super(64, cpool);
        this.a = new AnnotationEntryGen(value.getAnnotationEntry(), cpool, copyPoolEntries);
    }
    
    public AnnotationElementValueGen(final AnnotationEntryGen a, final ConstantPoolGen cpool) {
        super(64, cpool);
        this.a = a;
    }
    
    public AnnotationElementValueGen(final int type, final AnnotationEntryGen annotation, final ConstantPoolGen cpool) {
        super(type, cpool);
        if (type != 64) {
            throw new IllegalArgumentException("Only element values of type annotation can be built with this ctor - type specified: " + type);
        }
        this.a = annotation;
    }
    
    @Override
    public void dump(final DataOutputStream dos) throws IOException {
        dos.writeByte(super.getElementValueType());
        this.a.dump(dos);
    }
    
    public AnnotationEntryGen getAnnotation() {
        return this.a;
    }
    
    @Override
    public ElementValue getElementValue() {
        return new AnnotationElementValue(super.getElementValueType(), this.a.getAnnotation(), this.getConstantPool().getConstantPool());
    }
    
    @Override
    public String stringifyValue() {
        throw new UnsupportedOperationException("Not implemented yet");
    }
}
